; CW-Ider fr HB9DHK
; Januar 2006
; Michael Daehne
; DF1ZN



		list		p=16F627
		radix		hex
		__config	0x3FF1	;	INTRC oscillator!
dahlen	equ			d'99'	;	<== controls code speed..increase
ditlen	equ			d'33'	;	<== (though not over 255) for
		org			0x000	;	slower code, decrease for
		MOVLW		00		;	faster code. Make sure the
		MOVWF		0A		;	top number is three times the bottom
		GOTO		start	
		NOP
		NOP
time	MOVF		30,W
		BTFSC		03,2
		GOTO		endtime
uptop	MOVLW		01
		MOVWF		2D
upagn	CLRF		2C
doagn	DECFSZ		2C,F
		GOTO		doagn
		DECFSZ		2D,F
		GOTO		upagn
		MOVLW		4A
		MOVWF		2C
upone	DECFSZ		2C,F
		GOTO		upone
		DECFSZ		30,F
		GOTO		uptop
endtime	RETLW		00

dah		MOVLW		01		;	subroutine to do dah
		MOVWF		2E
agn3dah	MOVLW		dahlen
		SUBWF		2E,W
		BTFSC		03,0
		GOTO		enddah
		BSF			06,1	;	turn on pin B1
		MOVLW		01
		MOVWF		30
		CALL		time	;	wait 1 millisecond
		BCF			06,1	;	turn off pin B1
		MOVLW		01
		MOVWF		30
		CALL		time	;	wait 1 millisecond
		MOVF		2E,W
		INCF		2E,F
		GOTO		agn3dah	;	loop up to do it again.
enddah	MOVLW		3C		;	add a small delay
		MOVWF		30
		CALL		time	;	wait 1 millisecond
		RETLW		00

dit		MOVLW		01		;	subroutine to do a dit
		MOVWF		2E
agn3dit	MOVLW		ditlen
		SUBWF		2E,W
		BTFSC		03,0
		GOTO 		enddit
		BSF			06,1	;	turn on Pin B1
		MOVLW		01
		MOVWF		30
		CALL		time	;	wait 1 millisecond
		BCF			06,1	;	turn off Pin B1
		MOVLW		01
		MOVWF		30
		CALL		time	;	wait 1 millisecond
		MOVF		2E,W
		INCF		2E,F
		GOTO		agn3dit	;	loop up and do it again
enddit	MOVLW		3C		;	add a small delay
		MOVWF		30
		CALL		time	;	wait 1 millisecond
		RETLW		00

lspace	MOVLW		0xB4	;	subroutine to make a		
		MOVWF		30		;	letter space
		CALL		time
		RETLW		00

start	CLRF		04		; ***** Main program starts here *****
		MOVLW		0xF9	; Define Port B, Bit 1 and Bit 2 as output
		TRIS		6

top		BSF			06,2	;	turn on pin B2 (PTT on, wait 3 spaces)
		CALL		lspace	
		CALL		lspace	
		CALL		lspace	

		CALL		dit		;	transmit HB9DHK
		CALL		dit		;	'H'	
		CALL		dit
		CALL		dit

		CALL		lspace	

		CALL		dah		;	'B'
		CALL		dit
		CALL		dit
		CALL		dit

		CALL		lspace	

		CALL		dah		;	'9'
		CALL		dah
		CALL		dah
		CALL		dah
		CALL		dit

		CALL		lspace	

		CALL		dah		;	'D'
		CALL		dit
		CALL		dit

		CALL		lspace	

		CALL		dit		;	'H'
		CALL		dit
		CALL		dit
		CALL		dit

		CALL		lspace	

		CALL		dah		;	'K'
		CALL		dit
		CALL		dah

		CALL		lspace	
		CALL		lspace	
		CALL		lspace	

		CALL		dah		;	'Q'
		CALL		dah
		CALL		dit
		CALL		dah

		CALL		lspace	

		CALL		dit		;	'R'
		CALL		dah
		CALL		dit

		CALL		lspace	

		CALL		dit		;	'V'
		CALL		dit
		CALL		dit
		CALL		dah

		CALL		lspace	
		CALL		lspace	
		CALL		lspace	

		BCF			06,2	;	turn off pin B2 (PTT off)

		MOVLW 		01
		MOVWF		2E

							;	this code programs the delay
							;	between IDs.
loop	MOVLW		d'50'	;	<=4 x this number of seconds
							;	between IDs when using a 4 MHz Osc.
		SUBWF		2E,W	
		BTFSC		03,0
		GOTO		bottom
		MOVLW		10
		MOVWF		2F
again	MOVLW		0xFA
		MOVWF		30
		CALL		time
		DECFSZ		2F,F
		GOTO		again
		MOVF		2E,W
		INCF		2E,F
		GOTO		loop
bottom	GOTO		top

		END
		



		

	
